//--------------------------------------------------------------------- 
#include "MainWindow.h" 
//--------------------------------------------------------------------- 
BEditorWindow::BEditorWindow(BRect frame,const char *title) 
    :BWindow(frame,title,MAINWINDOW_WINDOWSTYLE,0) 
{ 
    mainview=new BEditorView(Bounds());    
    AddChild(mainview); 
} 
//--------------------------------------------------------------------- 
void BEditorWindow::MessageReceived(BMessage *msg) 
{ 
    switch(msg->what) 
    { 
        case B_UNDO: 
        case B_COPY: 
        case B_CUT: 
        case B_PASTE: 
        case B_SELECT_ALL: 
            ((BMemoView *)FindView("memo"))->MessageReceived(msg); 
            break; 
        case MSG_SAVE: 
            break; 
        case MSG_SAVEAS: 
            break; 
        default: 
            BWindow::MessageReceived(msg); 
    } 
} 
//--------------------------------------------------------------------- 
BEditorView::BEditorView(BRect frame) 
    :BView(frame,"beditorview",B_FOLLOW_ALL,B_WILL_DRAW) 
{ 
    BRect viewrect(Bounds()); 
    BMenuBar *mainmenu=new BMenuBar(BRect(0,0,viewrect.right, 
                                          be_plain_font->Size()*2), 
                                    "mainmenubar"); 
    AddChild(mainmenu); 

    memo=new BMemoView(BRect(0,be_plain_font->Size()*2, 
                 viewrect.right-B_V_SCROLL_BAR_WIDTH, 
                 viewrect.bottom-B_H_SCROLL_BAR_HEIGHT), 
               "memo",B_FOLLOW_ALL); 
    BScrollView *scr=new BScrollView("memoscroll",memo, 
                     B_FOLLOW_ALL,0,true,true); 
    AddChild(scr); 

    BMenu *filemenu=new BMenu("File"); 
    filemenu->AddItem(new BMenuItem("Open...",new BMessage(MSG_OPEN))); 
    filemenu->ItemAt(0)->SetTarget(be_app); 
    filemenu->AddItem(new BMenuItem("Save",new BMessage(MSG_SAVE))); 
    filemenu->AddItem(new BMenuItem("Save As...",new BMessage(MSG_SAVEAS))); 
    filemenu->AddSeparatorItem(); 
    filemenu->AddItem(new BMenuItem("Quit",new BMessage(B_QUIT_REQUESTED))); 
    mainmenu->AddItem(filemenu); 

    BMenu *editmenu=new BMenu("Edit"); 
    editmenu->AddItem(new BMenuItem("Undo",new BMessage(B_UNDO))); 
    editmenu->AddSeparatorItem(); 
    editmenu->AddItem(new BMenuItem("Copy",new BMessage(B_COPY))); 
    editmenu->AddItem(new BMenuItem("Cut",new BMessage(B_CUT))); 
    editmenu->AddItem(new BMenuItem("Paste",new BMessage(B_PASTE))); 
    editmenu->AddItem(new BMenuItem("Select All",new BMessage(B_SELECT_ALL))); 
    mainmenu->AddItem(editmenu); 

    memo->SetDoesUndo(true); 
} 
//--------------------------------------------------------------------- 
void BEditorWindow::OpenFile(BEntry *entry) 
{ 
    if(entry->Exists()) 
    { 
        BFile fil; 
        off_t size; 
                
        fil.SetTo(entry,B_READ_ONLY); 
        fil.GetSize(&size); 
        ((BTextView *)FindView("memo"))->SetText(&fil,0,size); 
    } 
} 
//--------------------------------------------------------------------- 